'File Name     : SPACE.BAS
'Program Name  : SPACE FIGHTER
'Version       : Ver 1.1
'Type          : Freeware
'Developed     : 15/3/98
'Author        : Ivan Wright
'
'Thanks for downloading Space Fighter!
'Please read through the text below before starting this program.
'
'This program may be freely distrubuted Providing no changes are
'made to the source code.
'This program may NOT be distrubuted Compiled.
'
'System Requirements
'------ ------------
'Display  :VGA (256 Colours)
'Dos      :Ver 5 Or Above
'RAM      :8 MB
'Procesor :486 Or Above
'Sound    :PC Speaker
'Speed    :33 MHz Or Above
'
'Instructions
'------------
'You play as the gun, stopping the aliens from reaching the botton
'of the screen (Earth) if they do reach the bottom you die.
'The aliens attack in Attack Waves. During these waves
'You have to kill the aliens by using your Laser Gun.
'As the Wave number increases the Amount and Speed of the aliens increases.
'
'Controls
'--------
'Left Key  :Moves the Gun Left.
'6         :Same as Left Key   
'Right Key :Moves the Gun Right.
'4         :Same as Right Key
'Space Bar :Fires ONE Laser Shot.
'Plus (+)  :Pauses the Game.
'Minus (-) :Exits the game.
'Esc       :Same as Minus.
'
'
'Press F5 to start.
'Enjoy the game...
    

TYPE ScoresType                                       'Type For Scores
  Ran AS INTEGER                                      'Rank
  Dat AS STRING * 8                                   'Date
  Nam AS STRING * 20                                  'Name
  Wav AS SINGLE                                       'Wave
  Scr AS LONG                                         'Score
END TYPE                                              'End Type

                                                      'Subs
DECLARE SUB DoReset ()
DECLARE SUB EnterPass ()
DECLARE SUB ExitGame ()
DECLARE SUB GetAlien ()
DECLARE SUB GetInfo ()
DECLARE SUB GetLevel ()
DECLARE SUB GetLogo (X, Y)
DECLARE SUB GetScores ()
DECLARE SUB GetTitle ()
DECLARE SUB HoldOn (Seconds)
DECLARE SUB MovAlien ()
DECLARE SUB Pause ()
DECLARE SUB PSFX3x4Font (X, Y, Text$, Colour)
DECLARE SUB RemAlien ()
DECLARE SUB Setup ()
DECLARE SUB ShowScores (Mode)
DECLARE SUB SoundFx (FX%)

DECLARE FUNCTION Event ()                             'Functions
DECLARE FUNCTION GetNumber% (Limit%)                  'Random Number
DECLARE FUNCTION InputPass$ (Length)                  'Password Input
DECLARE FUNCTION InputText$ (X, Y, Length, Col)       'Normal Input
                                                      'Global Variables
COMMON SHARED Aliens, AlienB, AlienC, AlienP
COMMON SHARED AOS, AOSLimit, BX, BY, CX, CY
COMMON SHARED Dead, GX, GY, Lives%, PX, PY, Rank
COMMON SHARED Score&, Speed, TempA, Wave

CONST Left = -75                                      'Mapped Key Values
CONST Right = -77
CONST Enter = 13
CONST Esc = 27
CONST Space = 32
CONST Plus = 43
CONST Minus = 45
CONST Four = 52
CONST Six = 54
                  
CONST XMin = 52                                       'Attack area
CONST XMax = 254
CONST YMin = 30
CONST YMax = 182

CONST False = 0                                       'Other
CONST True = 1
CONST PI = 3.14

DIM SHARED Beam(200) AS INTEGER                       'Set graphic Arrays
DIM SHARED Gun(200) AS INTEGER                        'Ditto
DIM SHARED Bomber(200) AS INTEGER                     'Ditto
DIM SHARED Chaser(200) AS INTEGER                     'Ditto
DIM SHARED Logo(2600) AS INTEGER                      'Ditto
DIM SHARED Pod(200) AS INTEGER                        'Ditto

DIM SHARED Scores(1 TO 10) AS ScoresType              'Array for Scores

SCREEN 13                                             'Set video
RANDOMIZE TIMER                                       'Random number generator

Setup                                                 'Setup
AOSLimit = 1                                          'Ditto
TempA = 6                                             'Ditto
Speed = .1                                            'Ditto
Wave = 1                                              'Ditto
Lives% = 5                                            'Ditto
GetTitle                                              'Title
CLS                                                   'Clear screen
DO                                                    'First Loop
  GetLevel                                            'Get Wave
  GY = 180                                            'Position gun
  GX = 160                                            'Ditto
  GetLogo 44, 0                                       'Get Logo
  LINE (50, 26)-(270, 190), 73, B                     'Draw attack area
  PUT (GX, GY), Gun, PSET                             'Draw the gun

  Aliens = TempA                                      'Aliens
  PSFX3x4Font 25, 10, STR$(Aliens), 15                'Information
  PSFX3x4Font -4, 10, "ALIENS", 15                    'Ditto
  PSFX3x4Font -4, 40, "LIVES", 15                     'Ditto
  PSFX3x4Font 22, 40, STR$(Lives%), 15                'Ditto
 
  DO                                                  'Second Loop
    RemAlien                                          'Remove Alien
    GetAlien                                          'Get Alien
    Dead = False                                      'Assume Living
    DO                                                'Third Loop
      MovAlien                                        'Move Alien
      HoldOn Speed                                    'Wait
      IF BY >= 178 THEN Dead = True                   'Check for dead
      IF CY >= 176 THEN Dead = True                   'Ditto
      IF PY >= 178 THEN Dead = True                   'Ditto
      Inpt = Event                                    'Input

    LOOP UNTIL Inpt OR Dead = True                    'End Loop
    RemAlien                                          'Remove Alien
    PUT (GX, GY), Gun                                 'Draw Gun

    SELECT CASE Inpt                                  'Read Input
      CASE Esc, Minus: ExitGame                       'Exit

      CASE Plus: Pause                                'Pause

      CASE Right, Six                                 'Right
        IF GX < 260 THEN GX = GX + 6                  'Check Boundry
        IF GX >= 260 THEN GX = GX + 0                 'Ditto

      CASE Left, Four                                 'Left
        IF GX > 54 THEN GX = GX - 6                   'Check Boundry
        IF GX <= 54 THEN GX = GX - 0                  'Ditto

      CASE Space                                      'Space Bar
        LINE (35, 5)-(49, 11), 0, BF                  'Fire
        PSFX3x4Font 25, 10, STR$(Aliens), 15          'Write Number of Aliens
        SoundFx 0                                     'Sound (Laser)
        PUT (GX + 4, 40), Beam, OR                    'Draw Beam
        HoldOn .1                                     'Wait

        SELECT CASE GX                                'Get Beam Position
          CASE BX TO BX + 8                           'Shoot Bomber
            IF BY >= 30 THEN                          'Check Length
              SoundFx 1                               'Sound (Death)
              Score& = Score& + 250                   'Increase Score
              AOS = AOS - 1                           'Remove AOS
              BX = 0: BY = 0                          'Back to 0
              AlienB = False                          'Remove Alien
              Aliens = Aliens - 1                     'Decrease Aliens
            END IF
          CASE CX - 2 TO CX + 3                       'Shoot Chaser
            IF CY >= 30 THEN                          'Check Length
              SoundFx 1                               'Sound (Death)
              Score& = Score& + 200                   'Increase Score
              AOS = AOS - 1                           'Remove AOS
              CX = 0: CY = 0                          'Back to 0
              AlienC = False                          'Remove Alien
              Aliens = Aliens - 1                     'Decrease Aliens
            END IF
          CASE PX TO PX + 5                           'Shoot Pod
            IF PY >= 30 THEN                          'Check Length
              SoundFx 1                               'Sound (Death)
              Score& = Score& + 500                   'Increase Score
              AOS = AOS - 1                           'Remove AOS
              PX = 0: PY = 0                          'Back to 0
              AlienP = False                          'Remove Alien
              Aliens = Aliens - 1                     'Decrease Aliens
            END IF
        END SELECT
 
      PUT (GX + 4, 40), Beam                          'Remove Beam
    END SELECT
    PUT (GX, GY), Gun, PSET                           'Remove Gun
  LOOP UNTIL Aliens = 0 OR Dead = True                'End Loop

  CLS                                                 'Clear Screen
  IF Dead = True THEN                                 'If Dead
    CLS                                               'You should know what this means
    Lives% = Lives% - 1                               'Reduce Lives
    IF Lives% = 0 THEN                                'Check for Game Over
      CLS                                             'You should know what this means
      PSFX3x4Font 120, 80, "GAME OVER", 4             'Write Game Over
      SoundFx (2)                                     'Sound (Dead)
      GetScores                                       'High Scores
      END                                             'End Game
    END IF                                            'If another chance
    SoundFx (2)                                       'Sound (Dead)
    Aliens = 0                                        'Reset
    Wave = Wave - 1                                   'Ditto
    DoReset                                           'Ditto
  END IF

  Wave = Wave + 1                                     'Increase Wave
  GetInfo                                             'Get Information
  PSFX3x4Font 120, 100, "POINTS:", 15                 'Write Information
  PSFX3x4Font 154, 100, STR$(Score&), 15              'Ditto
  PSFX3x4Font 120, 90, "ATTACK WAVE:", 15             'Ditto
  PSFX3x4Font 187, 90, STR$(Wave), 15                 'Ditto

  FOR I = 1 TO 2                                      'Stop accident of..
    DO: LOOP UNTIL Event                              '..hitting key
  NEXT
  CLS
  
  DoReset                                             'Reset
LOOP


'DATA to replace .SCR if it is deleted
DATA 1, "17/03/98", "IVAN WRIGHT", 25, 100000
DATA 2, "17/03/98", "DANIEL", 10, 9000
DATA 3, "17/03/98", "ANTHONY", 9, 8000
DATA 4, "17/03/98", "BEAU", 8, 7000
DATA 5, "17/03/98", "DENIS", 8, 6000
DATA 6, "17/03/98", "SOME ONE", 8, 5000
DATA 7, "17/03/98", "MORE GAMES COMING", 7, 4000
DATA 8, "17/03/98", "VERY SOON", 5, 3000
DATA 9, "17/03/98", "IN QB, VB", 3, 2000
DATA 10, "17/03/98", "OR C++..", 2, 1000

SUB DoReset
'Clear Alien Locations
 BX = XMin: BY = YMin
 CX = XMin: CY = YMin
 PX = XMin: PY = YMin

END SUB

SUB EnterPass
  DO
  PSFX3x4Font 0, 10, "PLEASE ENTER PASSWORD", 15
  Pass$ = InputPass$(6)
  
  SELECT CASE VAL(Pass$)
    CASE FIX(ATN(TAN(PI / 2.004312)) * 9954): Wave = 1
    CASE FIX(ATN(COS(PI / 5.643)) * 76120): Wave = 2
    CASE FIX(ATN(SIN(PI / 38.7743)) * 1116579): Wave = 3
    CASE FIX(ATN(ATN(PI / 42.8664)) * 1105212): Wave = 4
    CASE FIX(TAN(PI / 39.954) * 999421): Wave = 5
    CASE FIX(ATN(PI / 45.87) * 943215): Wave = 6
    CASE FIX(COS(PI / 40) * 34567): Wave = 7
    CASE FIX(SIN(COS(PI / 40)) * 43858): Wave = 8
    CASE FIX(SIN(COS(PI / 40)) * 83628): Wave = 9
    CASE FIX(COS(TAN(PI / 35.9855)) * 62847): Wave = 10
    CASE FIX(TAN(COS(PI / 5.643)) * 20967): Wave = 11
    CASE FIX(COS(COS(PI / 5.643)) * 76209): Wave = 12
    CASE FIX(SIN(SIN(PI / 5.643)) * 20967): Wave = 13
    CASE FIX(TAN(TAN(PI / 5.643)) * 43097): Wave = 14
    CASE FIX(TAN(PI / 5.643) * 61967): Wave = 15
    CASE FIX(SIN(PI / 5.643) * 70967): Wave = 16
    CASE FIX(SIN(PI / 5.643) * 93961): Wave = 17
    CASE FIX(ATN(TAN(PI / 10.6)) * 80954): Wave = 18
    CASE FIX(SIN(PI / 6.712) * 100045): Wave = 19
    CASE FIX(COS(PI / 2.673) * 49902): Wave = 20
    CASE FIX(COS(PI / 5.015) * 15152): Wave = 21
    CASE FIX(TAN(PI * 1.15) * 58689): Wave = 22
    CASE FIX(TAN(PI * 3.26) * 9878): Wave = 23
    CASE FIX(TAN(PI * 9.14) * 85272): Wave = 24
    CASE FIX(COS(PI / 5.1053) * 55969): Wave = 25
    CASE ELSE: PSFX3x4Font -4, 110, "PASS WORD NOT ACCEPTED!", 4
    HoldOn 4: Wave = 0
  END SELECT
  CLS
  LOOP UNTIL Wave >= 1
END SUB

FUNCTION Event

  Kee$ = UCASE$(INKEY$)                                 'Get Key

  IF Kee$ <> "" THEN
    IF LEN(Kee$) = 1 THEN                               'Check Length
      Keycode = ASC(Kee$)                               'Regular Ascii
    ELSE
      Keycode = -ASC(RIGHT$(Kee$, 1))                   'Extended Ascii
    END IF
  END IF

  Event = Keycode

END FUNCTION

SUB ExitGame
  DIM QBox(6912) AS INTEGER                         'Set array for Box
  X1 = 115: y1 = 47: X2 = 207: y2 = 99              'Set size
  GET (X1, y1)-(X2, y2), QBox                       'Get immage
  LINE (X1, y1)-(X2, y2), 14, BF                    'Draw Box
  LINE (X1, y1)-(X2, y2), 115, B                    'Ditto
  PSFX3x4Font 127, 60, "EXIT GAME", 0               'Message
  PSFX3x4Font 120, 67, "Y]ES     ", 0
  PSFX3x4Font 120, 74, "N]O      ", 0
  PSFX3x4Font 120, 82, "R]ESTART ", 0
  DO
    AKey$ = UCASE$(INKEY$)                          'Get key
    SELECT CASE AKey$
      CASE "Y": END                                 'Exit
      CASE "N": EXIT DO                             'Return
      CASE "R": RUN                                 'Re-start
    END SELECT
  LOOP

  PUT (X1, y1), QBox                                'Remove Box
  ERASE QBox                                        'Erase array
END SUB

SUB GetAlien
  RndNum1 = GetNumber(2)                        'Left or Right
  RndNum2 = GetNumber(80)                       'Top or Bottom
  RndNum2 = RndNum2 + 30
  IF AOS >= AOSLimit THEN EXIT SUB              'Enough Aliens?
  IF AOS < AOSLimit THEN                        'Not Enough Aliens
    SELECT CASE GetNumber(3)                    'Which one?
      CASE 1                                    'Bomber
        AOS = AOS + 1
        AlienB = True
        IF RndNum1 = 1 THEN BX = XMin
        IF RndNum1 = 2 THEN BX = XMax
        BY = RndNum2
        PUT (BX, BY), Bomber, PSET
      CASE 2                                    'Chaser
        AOS = AOS + 1
        AlienC = True
        IF RndNum1 = 1 THEN CX = XMin
        IF RndNum1 = 2 THEN CX = XMax
        CY = RndNum2
        PUT (CX, CY), Chaser, PSET
      CASE 3                                    'Pod
        AOS = AOS + 1
        AlienP = True
        IF RndNum1 = 1 THEN PX = XMin
        IF RndNum1 = 2 THEN PX = XMax
        PY = RndNum2
        PUT (PX, PY), Pod, PSET
    END SELECT
  END IF
END SUB

SUB GetInfo
  PSFX3x4Font 0, 10, "PASSWORD FOR WAVE", 15
  PSFX3x4Font 18 * 6, 10, STR$(Wave), 15
  SELECT CASE Wave
    CASE 1: PSFX3x4Font 0, 18, STR$(FIX(ATN(TAN(PI / 2.004312)) * 9954)), 15
    CASE 2: PSFX3x4Font 0, 18, STR$(FIX(ATN(COS(PI / 5.643)) * 76120)), 15
    CASE 3: PSFX3x4Font 0, 18, STR$(FIX(ATN(SIN(PI / 38.7743)) * 1116579)), 15
    CASE 4: PSFX3x4Font 0, 18, STR$(FIX(ATN(ATN(PI / 42.8664)) * 1105212)), 15
    CASE 5: PSFX3x4Font 0, 18, STR$(FIX(TAN(PI / 39.954) * 999421)), 15
    CASE 6: PSFX3x4Font 0, 18, STR$(FIX(ATN(PI / 45.87) * 943215)), 15
    CASE 7: PSFX3x4Font 0, 18, STR$(FIX(COS(PI / 40) * 34567)), 15
    CASE 8: PSFX3x4Font 0, 18, STR$(FIX(SIN(COS(PI / 40)) * 43858)), 15
    CASE 9: PSFX3x4Font 0, 18, STR$(FIX(SIN(COS(PI / 40)) * 83628)), 15
    CASE 10: PSFX3x4Font 0, 18, STR$(FIX(COS(TAN(PI / 35.9855)) * 62847)), 15
    CASE 11: PSFX3x4Font 0, 18, STR$(FIX(TAN(COS(PI / 5.643)) * 20967)), 15
    CASE 12: PSFX3x4Font 0, 18, STR$(FIX(COS(COS(PI / 5.643)) * 76209)), 15
    CASE 13: PSFX3x4Font 0, 18, STR$(FIX(SIN(SIN(PI / 5.643)) * 20967)), 15
    CASE 14: PSFX3x4Font 0, 18, STR$(FIX(TAN(TAN(PI / 5.643)) * 43097)), 15
    CASE 15: PSFX3x4Font 0, 18, STR$(FIX(TAN(PI / 5.643) * 61967)), 15
    CASE 16: PSFX3x4Font 0, 18, STR$(FIX(SIN(PI / 5.643) * 70967)), 15
    CASE 17: PSFX3x4Font 0, 18, STR$(FIX(SIN(PI / 5.643) * 93961)), 15
    CASE 18: PSFX3x4Font 0, 18, STR$(FIX(ATN(TAN(PI / 10.6)) * 80954)), 15
    CASE 19: PSFX3x4Font 0, 18, STR$(FIX(SIN(PI / 6.712) * 100045)), 15
    CASE 20: PSFX3x4Font 0, 18, STR$(FIX(COS(PI / 2.673) * 49902)), 15
    CASE 21: PSFX3x4Font 0, 18, STR$(FIX(COS(PI / 5.015) * 15152)), 15
    CASE 22: PSFX3x4Font 0, 18, STR$(FIX(TAN(PI * 1.15) * 58689)), 15
    CASE 23: PSFX3x4Font 0, 18, STR$(FIX(TAN(PI * 3.26) * 9878)), 15
    CASE 24: PSFX3x4Font 0, 18, STR$(FIX(TAN(PI * 9.14) * 85272)), 15
    CASE 25: PSFX3x4Font 0, 18, STR$(FIX(COS(PI / 5.1053) * 55969)), 15
  END SELECT
  
END SUB

SUB GetLevel
  SELECT CASE Wave                              'Get level
    CASE 1: TempA = 6: Speed = .1: AOSLimit = 1
    CASE 2: TempA = 8: Speed = .08: AOSLimit = 1
    CASE 3: TempA = 10: Speed = .08: AOSLimit = 1
    CASE 4: TempA = 12: Speed = .09: AOSLimit = 1
    CASE 5: TempA = 14: Speed = .07: AOSLimit = 1: Lives% = Lives% + 1
    CASE 6: TempA = 16: Speed = .07: AOSLimit = 1
    CASE 7: TempA = 18: Speed = .07: AOSLimit = 1
    CASE 8: TempA = 20: Speed = .06: AOSLimit = 1
    CASE 9: TempA = 22: Speed = .06: AOSLimit = 2
    CASE 10: TempA = 24: Speed = .05: AOSLimit = 2: Lives% = Lives% + 1
    CASE 11: TempA = 26: Speed = .05: AOSLimit = 2
    CASE 12: TempA = 28: Speed = .05: AOSLimit = 2
    CASE 13: TempA = 30: Speed = .05: AOSLimit = 2
    CASE 14: TempA = 32: Speed = .05: AOSLimit = 2
    CASE 15: TempA = 34: Speed = .03: AOSLimit = 2: Lives% = Lives% + 1
    CASE 16: TempA = 36: Speed = .02: AOSLimit = 2
    CASE 17: TempA = 38: Speed = .02: AOSLimit = 2
    CASE 18: TempA = 40: Speed = .02: AOSLimit = 2
    CASE 19: TempA = 42: Speed = .02: AOSLimit = 2
    CASE 20: TempA = 44: Speed = .02: AOSLimit = 3: Lives% = Lives% + 1
    CASE 21: TempA = 46: Speed = .01: AOSLimit = 3
    CASE 22: TempA = 48: Speed = .01: AOSLimit = 3
    CASE 23: TempA = 50: Speed = .01: AOSLimit = 3
    CASE 24: TempA = 52: Speed = .01: AOSLimit = 3
    CASE 25: TempA = 50: Speed = .001: AOSLimit = 3: Lives% = Lives% + 1
    CASE 26: TempA = 50: Speed = .001: AOSLimit = 3
    CASE 27: TempA = 54: Speed = .001: AOSLimit = 3

  END SELECT
   
END SUB

SUB GetLogo (X, Y)

PUT (X, Y), Logo, PSET                          'Draw Logo

END SUB

FUNCTION GetNumber% (Limit%)

  ANum% = INT(RND * Limit%) + 1                 'Random number generator

  GetNumber% = ANum%                            'Return number
END FUNCTION

SUB GetScores

  OPEN "SPACE.SCR" FOR RANDOM AS #1                    'Get .SCR File
  IF LOF(1) = 0 THEN                                   'If the file doesn't exist
    FOR N = 1 TO 10                                    'Count DATA
      READ A%, B$, C$, D!, E&                          'Read DATA
      Scores(N).Ran = A%                               'Store DATA
      Scores(N).Dat = B$                               'Ditto
      Scores(N).Nam = C$                               'Ditto
      Scores(N).Wav = D!                               'Ditto
      Scores(N).Scr = E&                               'Ditto
      PUT #1, N, Scores(N)                             'Save DATA
    NEXT
  END IF                                               'If the file exists
  FOR O = 1 TO 10                                      'Count Data
    GET #1, O, Scores(O)                               'Read Data
  NEXT

  FOR Rank = 1 TO 10                                   'Find Players Rank

    IF Score& > Scores(Rank).Scr THEN                  'Make it in?

      FOR Bump = 9 TO Rank STEP -1                     'Sort Scores
        Scores(Bump + 1).Ran = Scores(Bump + 1).Ran    'Bump ahead
        Scores(Bump + 1).Dat = Scores(Bump).Dat        'Ditto
        Scores(Bump + 1).Nam = Scores(Bump).Nam        'Ditto
        Scores(Bump + 1).Wav = Scores(Bump).Wav        'Ditto
        Scores(Bump + 1).Scr = Scores(Bump).Scr        'Ditto
     NEXT                                              'Bump next

     Day$ = MID$(DATE$, 4, 2)                          'Get Day
     Month$ = MID$(DATE$, 1, 2)                        'Get Month
     Year$ = MID$(DATE$, 9, 2)                         'Get Year
     Format$ = Day$ + "/" + Month$ + "/" + Year$       'Format the date
    
     Scores(Rank).Ran = Rank                           'Store Rank
     Scores(Rank).Dat = Format$                        'Store Date
     Scores(Rank).Scr = Score&                         'Store Score
     Scores(Rank).Wav = Wave                           'Store Wav
     Scores(Rank).Nam = ""                             'Delete Name
     ShowScores (0)                                    'Show all Scores
                                                       'Input Name
     Scores(Rank).Nam = InputText$(85, ((Rank * 10) + 49), 21, 1)

     ShowScores (0)                                    'Show all Scores
     EXIT FOR                                          'All done
   END IF
  NEXT

  FOR I = 1 TO 10
    PUT #1, I, Scores(I)                               'Save Data
  NEXT

  CLOSE #1                                             'Close .SCR

END SUB

SUB GetTitle                                    'Title screen
DIM Title(5000) AS INTEGER

  'S
  DRAW "bm130,50c14r10g3l7g3r7g9l10e3r7e3l7e8brbdp179,14bm130,50bg15c14d3r10u3blbdp179,14brbd2"
  DRAW "c14e9u3bd3blp179,14bdc14brbe6bu3d2g3u2brp179,14"
  'P
  DRAW "bm131,65c14e15r9g9l6be3e3r3g3l3bg3g6l3br2bup179,14bl2bdc14d3r3u3blbdp179,14brbd2c14"
  DRAW "e6u3bd2blp179,14brbdc14r6u3bd2blp179,14brbdc14e9u3bd2blp179,14 "
  'A
  DRAW "bm146,65c14e15r9g15l3e5l3g5l3br3be8e4r3g4l3bl2p179,14c14blbg8d3r3u3blbdp179,14brbu"
  DRAW "c14br3d3r3u3blbdp179,14brbd2c14e15u3bd2blp179,14"
  'C
  DRAW "bm162,65c14r9e3l6e9r6e3l9g15br2bup179,14c14bl2bdd3r9u3bdblp179,14c14brbd2e3u3blbd2p179,14"
  DRAW "brc14be12bu2d3g3u3brbdp179,14c14blbd2l5u2bdbrp179,14blbdc14g5bup179,14"
  'E
  DRAW "bm178,65c14r9e3l6e3r5e3l5e3r6e3l9g15d3r9u3bup179,14blbd2p179,14c14brbd2e3u3bd2bl"
  DRAW "p179,14c14brbu2be3d2e3u2bdblp179,14bdbrbe3c14bdu3be3d3g3bu2brp179,14"
  'F
  DRAW "bm95,90c14e15r9g3l6g3r5g3l5g6l3br2bup179,14bl2bdc14d3r3u3blbd2p179,14bdbrc14e6u3bd2bl"
  DRAW "p179,14bdc14brr5u3bd2blp179,14bdc14bre3u3bd2blp179,14c14bdbr2be3u3be3d3g3bu2brp179,14"
  'I
  DRAW "bm111,90c14e15r3g15l3br2bup179,14bdc14bl2d3r3u3bd2blp179,14bdbrc14e15u3bd2blp179,14"
  'G
  DRAW "bm121,90c14e15r9g3l6g9r3e3r3g6l9br2bup179,14bl2bdc14d3r9u3bd2blp179,14c14bdbre6"
  DRAW "u3bd2blp179,14bdbrc14be6u3be3d3g3bu2brp179,14"
  'H
  DRAW "bm137,90c14e15r3g6r3e6r3g15l3e6l3g6l3br2bup179,14bl2bdc14d3r3u3bdblp179,14bubr4"
  DRAW "c14d3r3u3bd2blp179,14bdbrc14e15u3bd2blp179,14"
  'T
  DRAW "bm155,90c14e12l3e3r9g3l3g12l3br2bup179,14bl2c14bdd3r3u3bd2blp179,14brbdc14e12u3bd2"
  DRAW "blp179,14bdbrc14r3u3bd2blp179,14brbdc14e3u3bd2blp179,14"
  'E
  DRAW "bm167,90c14r9e3l6e3r5e3l5e3r6e3l9g15d3r9u3bup179,14blbd2p179,14c14brbd2e3u3bd2bl"
  DRAW "p179,14c14brbu2be3d2e3u2bdblp179,14bdbrbe3c14bdu3be3d3g3bu2brp179,14"
  'R
  DRAW "bm183,90c14e15r9g9l6be3e3r3g3l3bg3f6l3h4g4l3br2bup179,14bl3bdc14d3r3u3bdblp179,14c14"
  DRAW "bd2br2re3f3u3bl2p179,14br2bd3c14r4u3blbdp179,14brbu4c14u3bd3e9u3bd2blp179,14"
  GET (92, 48)-(210, 98), Title
  PUT (92, 48), Title
  DO
  CLS
  PUT (90, 0), Title, PSET
  PSFX3x4Font 68, 70, "S P A C E   F I G H T E R", 14
  PSFX3x4Font 72, 90, "WRITTEN  BY  IVAN  WRIGHT", 1
  PSFX3x4Font 50, 120, "1: START NEW GAME", 15
  PSFX3x4Font 50, 127, "2: PASSWORD", 15
  PSFX3x4Font 50, 134, "3: VIEW HIGH SCORES", 15
  PSFX3x4Font 50, 141, "4: HELP", 15
  PSFX3x4Font 50, 148, "5: EXIT", 15
  PSFX3x4Font 85, 180, "PRESS 1 TO 5...", 2
 
  DO
    Menu = Event
  LOOP UNTIL Menu

    SELECT CASE Menu
      CASE 49: EXIT DO
      CASE 50
        CLS
        EnterPass
        EXIT DO

      CASE 51: ShowScores (1)

      CASE 52
        CLS
        PSFX3x4Font 0, 50, "ALL THE HELP TEXT IS AT THE BEGINING OF ", 15
        PSFX3x4Font 30, 60, "THE MAIN MODULE", 15
        DO: LOOP UNTIL Event

      CASE 53: END

  END SELECT
LOOP
END SUB

SUB HoldOn (Seconds)                            'Wait (Seconds)
  TTime = TIMER                                 'Set Timer
  DO
  LOOP UNTIL TIMER >= TTime + Seconds           'Loop
END SUB

FUNCTION InputPass$ (Length)
  DIM Edit$(Length)                                     'Dim array to edit
  Ele = 1                                               'First element

  DO
    DO                                                  'Event loop
      KeyIn = Event                                     'Anything happen?
      PSFX3x4Font -4 + Ele * 5, 91, "_", 31            'Draw cursor
      
    LOOP UNTIL KeyIn                                    'Back for event
      PSFX3x4Font -4 + Ele * 5, 91, "_", 0             'Blank cursor
      
     SELECT CASE KeyIn
      CASE Enter: EXIT DO                               'Enter
      CASE 1 TO 7, 9 TO 126                             'Regular keys
        REvent$ = CHR$(KeyIn)                          'Convert for printing
        IF Ele < Length THEN                            'Stay in bounds
          PSFX3x4Font -4 + Ele * 5, 91, "*", 31        'Print character
          Edit$(Ele) = REvent$                          'For backspace
          Ele = Ele + 1                                 'Adjust
          PSFX3x4Font -4 + Ele * 5, 91, "_", 31        'Draw cursor
        END IF
      CASE 8                                            'Backspace
       IF Ele > 1 THEN
         Ele = Ele - 1                                  'Adjust
         PSFX3x4Font -4 + Ele * 5, 91, "", 0          'Erase character
         PSFX3x4Font -4 + Ele * 5, 90, "_", 0          'Blank cursor
         PSFX3x4Font -4 + Ele * 5, 91, "_", 31
         Edit$(Ele) = CHR$(Space)                       'Clear element
       END IF
    END SELECT
  LOOP

  FOR N = 1 TO Length - 1                               'Put elements into a string
    IF Edit$(N) = "" THEN Edit$(N) = CHR$(Space)        'Replace nulls
    Tmp$ = Tmp$ + Edit$(N)                              'Create string
  NEXT N

  InputPass$ = LTRIM$(RTRIM$(Tmp$))
END FUNCTION

FUNCTION InputText$ (X, Y, Length, Col)
  DIM Edit$(Length)                                       'Dim array to edit
  Ele = 1                                                 'First element

  DO
    DO                                                    'Event loop
      KeyIn = Event                                       'Anything happen?
      PSFX3x4Font X + Ele * 5, Y, "_", Col                'Draw cursor
                                                   
    LOOP UNTIL KeyIn                                      'Back for event
      PSFX3x4Font X + Ele * 5, Y, "_", 0                  'Blank cursor
      SELECT CASE KeyIn                                   'Keyboard input
        CASE Enter: EXIT DO                               'Enter
        CASE 1 TO 7, 9 TO 126                             'Regular keys
          REvent$ = CHR$(KeyIn)                           'Convert for printing
          IF Ele < Length THEN                            'Stay in bounds
            PSFX3x4Font X + Ele * 5, Y, CHR$(KeyIn), Col  'Print character
            Edit$(Ele) = REvent$                          'For backspace
            Ele = Ele + 1                                 'Adjust
            PSFX3x4Font X + Ele * 5, Y, "_", Col         'Draw cursor
          END IF
        CASE 8                                            'Backspace
         IF Ele > 1 THEN
           Ele = Ele - 1                                  'Adjust
           PSFX3x4Font X + Ele * 5, Y, "", 0             'Erase character
           PSFX3x4Font X + Ele * 5, Y - 1, "_", 0         'Blank cursor
           PSFX3x4Font X + Ele * 5, Y, "_", Col
           Edit$(Ele) = CHR$(Space)                       'Clear element
         END IF
    END SELECT
  LOOP
 
  FOR N = 1 TO Length - 1                                 'Put elements into a string
    IF Edit$(N) = "" THEN Edit$(N) = CHR$(Space)          'Replace nulls
    Temp$ = Temp$ + Edit$(N)                              'Create string
  NEXT N

  InputText$ = Temp$

END FUNCTION

SUB MovAlien
  RemAlien
  IF AlienB = True THEN
   IF BY <= YMax THEN BY = BY + 4
    IF BX > GX THEN BX = BX - 4
    IF BX < GX THEN BX = BX + 4
    PUT (BX, BY), Bomber, PSET
  END IF
  IF AlienC = True THEN
  IF CY <= YMax THEN CY = CY + 4
    IF CX > GX THEN CX = CX - 4
    IF CX < GX THEN CX = CX + 4
    PUT (CX, CY), Chaser, PSET
  END IF
  IF AlienP = True THEN
    IF PY <= YMax THEN PY = PY + 4
    IF PX > GX THEN PX = PX - 4
    IF PX < GX THEN PX = PX + 4
    PUT (PX, PY), Pod, PSET
  END IF

END SUB

SUB Pause
  DIM Pa(400) AS INTEGER                        'Set array for PAUSE
  PSFX3x4Font -2, 26, "PAUSE", 42               'Message
  GET (0, 19)-(35, 35), Pa                      'Get image
  DO: LOOP UNTIL Event                          'Wait until key pressed
  PUT (0, 19), Pa                               'Remove immage
END SUB

SUB PSFX3x4Font (X, Y, Text$, Colour)
Length = LEN(Text$)                            'Get the length to print
FOR Char = 0 TO Length - 1
  Part$ = MID$(Text$, Char + 1, 1)
  SELECT CASE Part$                            'Move X and Y Cursor
    CASE "C": MoveX = MoveX + 7
    CASE "G": MoveX = MoveX + 7
    CASE "T": MoveX = MoveX + 7
    CASE "V": MoveX = MoveX + 8
    CASE "Y": MoveX = MoveX + 8
    CASE "0": MoveX = MoveX + 7
    CASE "4": MoveX = MoveX + 9
    CASE "7": MoveX = MoveX + 9
    CASE "]": MoveX = MoveX + 8
    CASE "'": MoveY = MoveY - 3: MoveX = MoveX + 6
    CASE "`": MoveY = MoveY - 3: MoveX = MoveX + 6
    CASE "!": MoveY = MoveY - 4: MoveX = MoveX + 8
    CASE "%": MoveY = MoveY - 5: MoveX = MoveX + 6
    CASE "+": MoveX = MoveX + 8
    CASE "-": MoveX = MoveX + 6: MoveY = MoveY - 2
    CASE " ": MoveX = MoveX + 7: GOTO Next2
    CASE ELSE: MoveX = MoveX + 6
  END SELECT
  PSET (X + MoveX, Y + MoveY), Colour          'Starting position
Next2:
  SELECT CASE Part$                            'The Fonts
    CASE "A": DRAW "u4r3d4bu2l2"
    CASE "B": DRAW "u4r2fglbrfgl"
    CASE "C": DRAW "r2bl2hu2er2": MoveX = MoveX - 1
    CASE "D": DRAW "u4r2fd2gl2"
    CASE "E": DRAW "u4r3bl3bdfrlgbdr3"
    CASE "F": DRAW "u4r3bl3bdfr"
    CASE "G": DRAW "hu2er2bl2bgbd2bfr2u": MoveX = MoveX - 1
    CASE "H": DRAW "u4bd2r3bd2u4"
    CASE "I": DRAW "ru4blr2blbd4r": MoveX = MoveX - 1
    CASE "J": DRAW "eu3blr2": MoveX = MoveX - 1
    CASE "K": DRAW "u4bd2e2bg2f2": MoveX = MoveX - 1
    CASE "L": DRAW "r2bl2u4": MoveX = MoveX - 1
    CASE "M": DRAW "u4f2e2d4": MoveX = MoveX + 2
    CASE "N": DRAW "u4f3du4"
    CASE "O": DRAW "u4r3d4l3"
    CASE "P": DRAW "u4r3d2l3"
    CASE "Q": DRAW "u4r3d4l3bubr2r2": MoveX = MoveX + 1
    CASE "R": DRAW "u4r3d2l3brf2"
    CASE "S": DRAW "r3u2l3u2r3"
    CASE "T": DRAW "u4lbrr": MoveX = MoveX - 2
    CASE "U": DRAW "bu4d4r3u4"
    CASE "V": DRAW "h2u2br4d2g2"
    CASE "W": DRAW "bu4d4refru4": MoveX = MoveX + 2
    CASE "X": DRAW "e4bl4f4": MoveX = MoveX + 2
    CASE "Y": DRAW "u2h2br4g2": MoveX = MoveX - 1
    CASE "Z": DRAW "br3l3ue3l3"
    CASE "0": DRAW "hu2er2fd2gl2"
    CASE "1": DRAW "r2blu4g"
    CASE "2": DRAW "r3bl3e2uhl"
    CASE "3": DRAW "r3uhlbreul3"
    CASE "4": DRAW "u4bd2l3u2": MoveX = MoveX - 3
    CASE "5": DRAW "r2ehl2u2r3"
    CASE "6": DRAW "u4r3bl3bd2r3d2l3"
    CASE "7": DRAW "u4l3": MoveX = MoveX - 3
    CASE "8": DRAW "u4r3d2l3br3d2l3"
    CASE "9": DRAW "r3u2l3u2r3d2"
    CASE "[": DRAW "rblu4r": MoveX = MoveX - 2
    CASE "]": DRAW "ru4l": MoveX = MoveX - 2
    CASE "'": DRAW "e": MoveY = MoveY + 3: MoveX = MoveX - 3
    CASE "`": DRAW "h": MoveY = MoveY + 3: MoveX = MoveX - 3
    CASE ",": DRAW "g": MoveX = MoveX - 3
    CASE ".": MoveX = MoveX - 3
    CASE "!"
      DRAW "d2": PSET STEP(0, 2), Colour
      MoveY = MoveY + 4: MoveX = MoveX - 3
    CASE "%": DRAW "d2br2u2": MoveY = MoveY + 5              '"
    CASE "_": DRAW "r3"                                      'Cursor
    CASE "": PSET STEP(0, -2), 0: DRAW "u6rd6ru6rd6ru6rd6"  'Blank
    CASE ":": PSET STEP(0, -4), Colour
    CASE "*": DRAW "e4bg2u2bd2d2bu2f2bh2h2"
    CASE "/": DRAW "e4": MoveX = MoveX + 1
    CASE "+": DRAW "u4bd2l2br2r2": MoveX = MoveX - 2
    CASE "-": DRAW "r3": MoveY = MoveY + 2
  END SELECT
NEXT
END SUB

SUB RemAlien

  IF AlienB = True THEN PUT (BX, BY), Bomber
 
  IF AlienC = True THEN PUT (CX, CY), Chaser

  IF AlienP = True THEN PUT (PX, PY), Pod
  
END SUB

SUB Setup

  DRAW "bm0,0bd4d3r8u3l3u4l2d4l3brbdp15,15"
  GET (0, 0)-(10, 8), Gun
  PUT (0, 0), Gun

  DRAW "bm0,5c104r8e5l8g5br2bup53,104c104bl2bdd2r8u2bdblp53,104c104brbde5u2bdc53g5"
  GET (0, 0)-(14, 8), Bomber
  PUT (0, 0), Bomber

  DRAW "bm4,0c42g3f3e3h3bdp42,42bd5d2g3f3e3h3bdp42,42bdbl3u6br6d6"
  GET (0, 0)-(8, 14), Chaser
  PUT (0, 0), Chaser

  DRAW "bm10,0c68d2f2r2d2l2g2d2l2u2h2l2u2r2e2u2r2blbd4p68,68"
  GET (0, 0)-(15, 10), Pod
  PUT (0, 0), Pod

  DRAW "bm0,0c14d140"
  GET (0, 0)-(1, 140), Beam
  PUT (0, 0), Beam

'S
DRAW "bm30,5c14r10g3l7g3r7g9l10e3r7e3l7e8brbdp179,14bm30,5bg15c14d3r10u3blbdp179,14brbd2"
DRAW "c14e9u3bd3blp179,14bdc14brbe6bu3d2g3u2brp179,14"
'P
DRAW "bm31,20c14e15r9g9l6be3e3r3g3l3bg3g6l3br2bup179,14bl2bdc14d3r3u3blbdp179,14brbd2c14"
DRAW "e6u3bd2blp179,14brbdc14r6u3bd2blp179,14brbdc14e9u3bd2blp179,14 "
'A
DRAW "bm46,20c14e15r9g15l3e5l3g5l3br3be8e4r3g4l3bl2p179,14c14blbg8d3r3u3blbdp179,14brbu"
DRAW "c14br3d3r3u3blbdp179,14brbd2c14e15u3bd2blp179,14"
'C
DRAW "bm62,20c14r9e3l6e9r6e3l9g15br2bup179,14c14bl2bdd3r9u3bdblp179,14c14brbd2e3u3blbd2p179,14"
DRAW "brc14be12bu2d3g3u3brbdp179,14c14blbd2l5u2bdbrp179,14blbdc14g5bup179,14"
'E
DRAW "bm78,20c14r9e3l6e3r5e3l5e3r6e3l9g15d3r9u3bup179,14blbd2p179,14c14brbd2e3u3bd2bl"
DRAW "p179,14c14brbu2be3d2e3u2bdblp179,14bdbrbe3c14bdu3be3d3g3bu2brp179,14"
'F
DRAW "bm115,20c14e15r9g3l6g3r5g3l5g6l3br2bup179,14bl2bdc14d3r3u3blbd2p179,14bdbrc14e6u3bd2bl"
DRAW "p179,14bdc14brr5u3bd2blp179,14bdc14bre3u3bd2blp179,14c14bdbr2be3u3be3d3g3bu2brp179,14"
'I
DRAW "bm131,20c14e15r3g15l3br2bup179,14bdc14bl2d3r3u3bd2blp179,14bdbrc14e15u3bd2blp179,14"
'G
DRAW "bm141,20c14e15r9g3l6g9r3e3r3g6l9br2bup179,14bl2bdc14d3r9u3bd2blp179,14c14bdbre6"
DRAW "u3bd2blp179,14bdbrc14be6u3be3d3g3bu2brp179,14"
'H
DRAW "bm157,20c14e15r3g6r3e6r3g15l3e6l3g6l3br2bup179,14bl2bdc14d3r3u3bdblp179,14bubr4"
DRAW "c14d3r3u3bd2blp179,14bdbrc14e15u3bd2blp179,14"
'T
DRAW "bm175,20c14e12l3e3r9g3l3g12l3br2bup179,14bl2c14bdd3r3u3bd2blp179,14brbdc14e12u3bd2"
DRAW "blp179,14bdbrc14r3u3bd2blp179,14brbdc14e3u3bd2blp179,14"
'E
DRAW "bm187,20c14r9e3l6e3r5e3l5e3r6e3l9g15d3r9u3bup179,14blbd2p179,14c14brbd2e3u3bd2bl"
DRAW "p179,14c14brbu2be3d2e3u2bdblp179,14bdbrbe3c14bdu3be3d3g3bu2brp179,14"
'R
DRAW "bm203,20c14e15r9g9l6be3e3r3g3l3bg3f6l3h4g4l3br2bup179,14bl3bdc14d3r3u3bdblp179,14c14"
DRAW "bd2br2re3f3u3bl2p179,14br2bd3c14r4u3blbdp179,14brbu4c14u3bd3e9u3bd2blp179,14"
GET (12, 3)-(230, 25), Logo
PUT (12, 3), Logo

END SUB

SUB ShowScores (Mode)
  IF Mode = 1 THEN                                          'Need Data?
    OPEN "SPACE.SCR" FOR RANDOM AS #1                       'Open .SCR FIle
    FOR Num = 1 TO 10                                       'Count Data
      GET #1, Num, Scores(Num)                              'Get Data
    NEXT
    CLOSE #1                                                'Close .SCR
  END IF
    
  X1 = 4: X2 = 30: X3 = 90: X4 = 210: X5 = 240              'Set X Axis
  Num = 1                                                   'Set Scores Num
  CLS                                                       'Clear Screen
  GetLogo 44, 0                                             'Get Logo
  PSFX3x4Font 100, 31, "HALL  OF  FAME", 14                 'Titles
  PSFX3x4Font -4, 46, "RANK    DATE         NAME       WAVE  SCORE", 14

  FOR Y = 58 TO 157 STEP 10                                 'Count Y
    IF Scores(Num).Ran = Rank THEN                          'Y Axis
      PSFX3x4Font X1, Y, STR$(Scores(Num).Ran), 1           'Write Data
      PSFX3x4Font X2, Y, Scores(Num).Dat, 1                 'Ditto
      PSFX3x4Font X3, Y, Scores(Num).Nam, 1                 'Ditto
      PSFX3x4Font X4, Y, STR$(Scores(Num).Wav), 1           'Ditto
      PSFX3x4Font X5, Y, STR$(Scores(Num).Scr), 1           'Ditto
    ELSEIF Scores(Num).Ran <> Rank THEN
      PSFX3x4Font X1, Y, STR$(Scores(Num).Ran), 14          'Ditto
      PSFX3x4Font X2, Y, Scores(Num).Dat, 14                'Ditto
      PSFX3x4Font X3, Y, Scores(Num).Nam, 14                'Ditto
      PSFX3x4Font X4, Y, STR$(Scores(Num).Wav), 14          'Ditto
      PSFX3x4Font X5, Y, STR$(Scores(Num).Scr), 14          'Ditto
    END IF
    Num = Num + 1                                           'Increase number
  NEXT

  IF Mode = 1 THEN                                          'To Hold
    DO: LOOP UNTIL Event
  END IF

END SUB

SUB SoundFx (FX%)
  SELECT CASE FX%

    CASE 0                                      'Laser
      Freq = 147
      FOR Scale = 6 TO 1 STEP -1
        Duration = Scale / 100
        Freq = Freq + 47
        SOUND Freq, Duration
      NEXT

    CASE 1                                      'Alien Die
      FOR Freq = 400 TO 200 STEP -10
        SOUND Freq, .1
      NEXT

    CASE 2                                      'Player Die
      FOR FreqA = 500 TO 100 STEP -10
        SOUND FreqA, .1
        HoldOn .002
      NEXT
      FOR FreqB = 500 TO 100 STEP -10
        SOUND FreqB, .1
        HoldOn .005
      NEXT
     
  END SELECT
END SUB

