DECLARE SUB GetScores ()
DECLARE SUB ShowScores ()
DECLARE SUB PSFX3x4Font (X, Y, Text$, Colour)
DECLARE FUNCTION InputText$ (X, Y, Length, Col)
DECLARE FUNCTION event ()

COMMON SHARED Score&, Rank

TYPE ScoresType
  Ran AS INTEGER
  Dat AS STRING * 8
  Nam AS STRING * 20
  Wav AS SINGLE
  Scr AS LONG
END TYPE
 
SCREEN 13
DIM SHARED Scores(1 TO 10) AS ScoresType

CONST Left = -75                                      'Mapped Key Values
CONST Right = -77
CONST Enter = 13
CONST Esc = 27
CONST Space = 32
CONST Plus = 43
CONST Minus = 45
CONST Four = 52
CONST Six = 54

GetScores
DATA 1, "17/3/98", "IVAN WRIGHT", 10, 1000000
DATA 2, "17/3/98", "IVAN WRIGHT", 8, 9000
DATA 3, "17/3/98", "IVAN WRIGHT", 8, 8000
DATA 4, "17/3/98", "IVAN WRIGHT", 8, 7000
DATA 5, "17/3/98", "QWERTYUIOPASDFGHJKLZ", 8, 6000
DATA 6, "17/3/98", "IVAN WRIGHT", 8, 5000
DATA 7, "17/3/98", "IVAN WRIGHT", 8, 4000
DATA 8, "17/3/98", "IVAN WRIGHT", 8, 3000
DATA 9, "17/3/98", "IVAN WRIGHT", 8, 2000
DATA 10, "17/3/98", "IVAN WRIGHT", 8, 100

FUNCTION event
  Kee$ = UCASE$(INKEY$)                                 'Get Key

  IF Kee$ <> "" THEN
    IF LEN(Kee$) = 1 THEN                               'Check Length
      Keycode = ASC(Kee$)                               'Regular Ascii
    ELSE
      Keycode = -ASC(RIGHT$(Kee$, 1))                   'Extended Ascii
    END IF
  END IF

  event = Keycode

END FUNCTION

SUB GetScores
  Score& = 6500
  KILL "SPACE.SCR"
  OPEN "SPACE.SCR" FOR RANDOM AS #1
  IF LOF(1) = 0 THEN
    FOR N = 1 TO 10
      READ A%, B$, C$, D!, E&
      Scores(N).Ran = A%
      Scores(N).Dat = B$
      Scores(N).Nam = C$
      Scores(N).Wav = D!
      Scores(N).Scr = E&
      PUT #1, N, Scores(N)
    NEXT
  END IF
  FOR O = 1 TO 10
    GET #1, O, Scores(O)
  NEXT

 FOR Rank = 1 TO 10                                  'find players rank

   IF Score& > Scores(Rank).Scr THEN         'make the list ?

     FOR Bump = 9 TO Rank STEP -1                   'sort it
        Scores(Bump + 1).Ran = Scores(Bump + 1).Ran        'bump ahead
        Scores(Bump + 1).Dat = Scores(Bump).Dat        'ditto
        Scores(Bump + 1).Nam = Scores(Bump).Nam        'ditto
        Scores(Bump + 1).Wav = Scores(Bump).Wav
        Scores(Bump + 1).Scr = Scores(Bump).Scr        'ditto
     NEXT                                            'bump next

     Month$ = MID$(DATE$, 1, 2)                      'get month
     Day$ = MID$(DATE$, 4, 2)                        'get day
     Year$ = MID$(DATE$, 9, 2)                       'get year
     Format$ = Day$ + "/" + Month$ + "/" + Year$     'format the date
     Scores(Rank).Ran = Rank
     Scores(Rank).Dat = Format$                       'store it
     Scores(Rank).Scr = Score&                     'store gamescore
     Scores(Rank).Nam = ""
     ShowScores
     Scores(Rank).Nam = InputText$(85, Rank * 9 + 29, 21, 1)
     ShowScores
     EXIT FOR                                        'all done
   END IF
  NEXT

  FOR I = 1 TO 10
    PUT #1, I, Scores(I)
  NEXT

  CLOSE #1

END SUB

FUNCTION InputText$ (X, Y, Length, Col)
  DIM Edit$(Length)                                       'Dim array to edit
  Ele = 1                                                 'First element

  DO
    DO                                                    'Event loop
      KeyIn = event                                       'Anything happen?
      PSFX3x4Font X + Ele * 5, Y, "_", Col                'Draw cursor
                                                  
    LOOP UNTIL KeyIn                                      'Back for event
      PSFX3x4Font X + Ele * 5, Y, "_", 0                  'Blank cursor
      SELECT CASE KeyIn                                   'Keyboard input
        CASE Enter: EXIT DO                               'Enter
        CASE 1 TO 7, 9 TO 126                             'Regular keys
          REvent$ = CHR$(KeyIn)                           'Convert for printing
          IF Ele < Length THEN                            'Stay in bounds
            PSFX3x4Font X + Ele * 5, Y, CHR$(KeyIn), Col  'Print character
            Edit$(Ele) = REvent$                          'For backspace
            Ele = Ele + 1                                 'Adjust
            PSFX3x4Font X + Ele * 5, Y, "_", Col          'Draw cursor
          END IF
        CASE 8                                            'Backspace
         IF Ele > 1 THEN
           Ele = Ele - 1                                  'Adjust
           PSFX3x4Font X + Ele * 5, Y, "", 0             'Erase character
           PSFX3x4Font X + Ele * 5, Y - 1, "_", 0         'Blank cursor
           PSFX3x4Font X + Ele * 5, Y, "_", Col
           Edit$(Ele) = CHR$(Space)                       'Clear element
         END IF
    END SELECT
  LOOP

  FOR N = 1 TO Length - 1                                 'Put elements into a string
    IF Edit$(N) = "" THEN Edit$(N) = CHR$(Space)          'Replace nulls
    Temp$ = Temp$ + Edit$(N)                              'Create string
  NEXT N

  InputText$ = Temp$

END FUNCTION

SUB PSFX3x4Font (X, Y, Text$, Colour)
Length = LEN(Text$)                            'Get the length to print
FOR Char = 0 TO Length - 1
  Part$ = MID$(Text$, Char + 1, 1)
  SELECT CASE Part$                            'Move X and Y Cursor
    CASE "C": MoveX = MoveX + 7
    CASE "G": MoveX = MoveX + 7
    CASE "T": MoveX = MoveX + 7
    CASE "V": MoveX = MoveX + 8
    CASE "Y": MoveX = MoveX + 8
    CASE "c": MoveX = MoveX + 7
    CASE "e": MoveX = MoveX + 7
    CASE "f": MoveX = MoveX + 7
    CASE "i": MoveX = MoveX + 7
    CASE "j": MoveX = MoveX + 7
    CASE "t": MoveX = MoveX + 8
    CASE "v": MoveX = MoveX + 8
    CASE "0": MoveX = MoveX + 7
    CASE "4": MoveX = MoveX + 9
    CASE "7": MoveX = MoveX + 9
    CASE "]": MoveX = MoveX + 8
    CASE "'": MoveY = MoveY - 3: MoveX = MoveX + 6
    CASE "`": MoveY = MoveY - 3: MoveX = MoveX + 6
    CASE "!": MoveY = MoveY - 4: MoveX = MoveX + 8
    CASE "%": MoveY = MoveY - 5: MoveX = MoveX + 6
    CASE " ": MoveX = MoveX + 7: GOTO Next2
    CASE ELSE: MoveX = MoveX + 6
  END SELECT
  PSET (X + MoveX, Y + MoveY), Colour          'Starting position
Next2:
  SELECT CASE Part$                            'The Fonts
    CASE "A": DRAW "u4r3d4bu2l2"
    CASE "B": DRAW "u4r2fglbrfgl"
    CASE "C": DRAW "r2bl2hu2er2": MoveX = MoveX - 1
    CASE "D": DRAW "u4r2fd2gl2"
    CASE "E": DRAW "u4r3bl3bdfrlgbdr3"
    CASE "F": DRAW "u4r3bl3bdfr"
    CASE "G": DRAW "hu2er2bl2bgbd2bfr2u": MoveX = MoveX - 1
    CASE "H": DRAW "u4bd2r3bd2u4"
    CASE "I": DRAW "ru4blr2blbd4r": MoveX = MoveX - 1
    CASE "J": DRAW "eu3blr2": MoveX = MoveX - 1
    CASE "K": DRAW "u4bd2e2bg2f2": MoveX = MoveX - 1
    CASE "L": DRAW "r2bl2u4": MoveX = MoveX - 1
    CASE "M": DRAW "u4f2e2d4": MoveX = MoveX + 2
    CASE "N": DRAW "u4f3du4"
    CASE "O": DRAW "u4r3d4l3"
    CASE "P": DRAW "u4r3d2l3"
    CASE "Q": DRAW "u4r3d4l3bubr2r2": MoveX = MoveX + 1
    CASE "R": DRAW "u4r3d2l3brf2"
    CASE "S": DRAW "r3u2l3u2r3"
    CASE "T": DRAW "u4lbrr": MoveX = MoveX - 2
    CASE "U": DRAW "bu4d4r3u4"
    CASE "V": DRAW "h2u2br4d2g2"
    CASE "W": DRAW "bu4d4refru4": MoveX = MoveX + 2
    CASE "X": DRAW "e4bl4f4": MoveX = MoveX + 2
    CASE "Y": DRAW "u2h2br4g2": MoveX = MoveX - 2
    CASE "Z": DRAW "br3l3ue3l3"
    CASE "0": DRAW "hu2er2fd2gl2"
    CASE "1": DRAW "r2blu4g"
    CASE "2": DRAW "r3bl3e2uhl"
    CASE "3": DRAW "r3uhlbreul3"
    CASE "4": DRAW "u4bd2l3u2": MoveX = MoveX - 3
    CASE "5": DRAW "r2ehl2u2r3"
    CASE "6": DRAW "u4r3bl3bd2r3d2l3"
    CASE "7": DRAW "u4l3": MoveX = MoveX - 3
    CASE "8": DRAW "u4r3d2l3br3d2l3"
    CASE "9": DRAW "r3u2l3u2r3d2"
    CASE "[": DRAW "rblu4r": MoveX = MoveX - 2
    CASE "]": DRAW "ru4l": MoveX = MoveX - 2
    CASE "'": DRAW "e": MoveY = MoveY + 3: MoveX = MoveX - 3
    CASE "`": DRAW "h": MoveY = MoveY + 3: MoveX = MoveX - 3
    CASE ",": DRAW "g": MoveX = MoveX - 3
    CASE ".": MoveX = MoveX - 3
    CASE "!": DRAW "d2": PSET STEP(0, 2), Colour
    CASE "%": DRAW "d2br2u2": MoveY = MoveY + 5              '"
    CASE "_": DRAW "r3"                                      'Cursor
    CASE "": PSET STEP(0, -2), 0: DRAW "u6rd6ru6rd6ru6rd6"  'Blank
    CASE ":": PSET STEP(0, -4), Colour
    CASE "/": DRAW "e3"
  END SELECT
NEXT
END SUB

SUB ShowScores

X1 = 4: X2 = 30: X3 = 90: X4 = 210: X5 = 240
Num = 1
CLS
PSFX3x4Font -4, 30, "RANK    DATE         NAME       WAVE  SCORE", 14

FOR Y = 38 TO 127 STEP 9
  IF Scores(Num).Ran = Rank THEN
    PSFX3x4Font X1, Y, STR$(Scores(Num).Ran), 1
    PSFX3x4Font X2, Y, Scores(Num).Dat, 1
    PSFX3x4Font X3, Y, Scores(Num).Nam, 1
    PSFX3x4Font X4, Y, STR$(Scores(Num).Wav), 1
    PSFX3x4Font X5, Y, STR$(Scores(Num).Scr), 1
  ELSEIF Scores(Num).Ran <> Rank THEN
    PSFX3x4Font X1, Y, STR$(Scores(Num).Ran), 14
    PSFX3x4Font X2, Y, Scores(Num).Dat, 14
    PSFX3x4Font X3, Y, Scores(Num).Nam, 14
    PSFX3x4Font X4, Y, STR$(Scores(Num).Wav), 14
    PSFX3x4Font X5, Y, STR$(Scores(Num).Scr), 14
  END IF
  Num = Num + 1
NEXT
END SUB

